//
// C++ Interface: statistiktabelle
//
// Description: 
//
//
// Author: Priyanka Singh <priyanka@india-souring-research.com>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef STATISTIKTABELLE_H
#define STATISTIKTABELLE_H
#include "modelclient.h"
#include "textinhalt.h"
#include <QTableWidget>
#include <QMouseEvent>

class QAction;

/**
	@author Priyanka Singh <priyanka@india-souring-research.com>
*/
class StatistikTabelle:public ModelClient,public TextInhalt
{
	Q_OBJECT

public:
    StatistikTabelle();

    ~StatistikTabelle();
    
    void setSpalten(const QVector<int> &spalten);
    void setModel(QStandardItemModel *m);
    
    QString toText();
    QString toHTML();
    
    void setDepFilter(QString FilterWert,int Filter_Spalte);
    void setOutputFilter(const QVariant& fv);
    void setInputFilter(const QVariant& fv);
    
    void saveData(QDataStream& s,int ver=1);
    void loadData(QDataStream& s,int ver=1);

public slots:
        void updateDiagram();
	void depAction();
	void undepAction();
	
protected:
	QVector<int> Spalten;
	QTableWidget *table;
	QPoint dragStartPosition;
	QString filter_wert;
	QVariant input_filter,output_filter;
	int filter_spalte;
	QAction *aDep,*aUnDep;
	
protected:
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void contextMenuEvent ( QContextMenuEvent * event );
};

#endif

