#include <QPushButton>
#include <QMessageBox>
#include <QToolBar>
#include <QAction>
#include <QMenuBar>
#include <QMenu>
#include <QDockWidget>
#include <QStackedWidget>
#include <QComboBox>
#include <QLabel>
#include <QApplication>
#include <QFileDialog>
#include <QDir>
#include <QTextStream>
#include <QtDebug>
#include <QTableView>
#include <QInputDialog>
#include <QListView>
#include <QTextEdit>
#include <QClipboard>
#include <QSettings>
#include <QUndoStack>
#include <QBuffer>
#include <QSortFilterProxyModel>

#include <numeric>
#include <algorithm>

#include "view.h"
#include "haeufigkeitsdiagramadapter.h"
#include "haeufigkeitsprozentdiagramadapter.h"
#include "direktdiagramadapter.h"
#include "tortendiagram.h"
#include "tabelle1.h"
#include "vierdiagramview.h"
#include "balkendiagram.h"
#include "balkendiagram_h.h"
#include "xmasdiagram.h"
#include "spaltenhaeufigkeitsdiagramadapter.h"
#include "modelmultidiagramadapter.h"
#include "haeufigkeitsmultidiagramadapter.h"
#include "haeufigkeitsprozentmultidiagramadapter.h"
#include "direktmultidiagramadapter.h"
#include "modelaenlichkeitstabelle.h"
#include "modelaenlichkeits3dview.h"
#include "excelbalkendiagram.h"
#include "statistiktabelle.h"
#include "xyplotter.h"
#include "lineareregression.h"
#include "tabellendiagramm.h"
#include "haeufigkeitsverteilungsadapter.h"
#include "chiquadrat.h"

#include "columnselectdialog.h"

#include "chidecolumns.h"
#include "crenamecolumn.h"
#include "cinsertcolumn.h"
#include "cinsertdata.h"
#include "cremoveview.h"
#include "cappendcolumn.h"

// Dateiformatversion
#define FILEVERSION 3

View::View(QWidget *parent)
		:QMainWindow(parent),model(0),vmodel(0),curIdx(0),vList(0)
{
	Diagramme << "TortenDiagram" << "BalkenDiagram(V)"<<"BalkenDiagram(H)" << "ExcelBalkenDiagram" << "Tabelle" << "XmasDiagram";
	Adapter<< "H\344ufigkeit" << "H\344ufigkeit %" << "H\344ufigkeitsVerteilung" << "Direkt" << "Chi Quadrat";
	MultiAdapter << "H\344ufigkeit" << "H\344ufigkeit %"<< "Direkt" << "Spaltenh\344ufigkeit" ;
	DiagramOnly << "\304hnlichkeit" << "\304hnlichkeit 3D" << "Statistik" << "XYPlotter" << "Lineare Regression" << "Chi Quadrat";
	SingleDiagram << "Chi Quadrat";
	DualDiagram << "XYPlotter" << "Lineare Regression";
	MultiDiagram << "TortenDiagram" << "BalkenDiagram(V)"<<"BalkenDiagram(H)" << "ExcelBalkenDiagram" << "Tabelle"<< "\304hnlichkeit" << "\304hnlichkeit 3D" << "Statistik";

	model = new QStandardItemModel(10,5,this);
	vmodel = new QStandardItemModel(this);

	sw = new QStackedWidget;
	cb = new QComboBox();
	cb->setModel(vmodel);

	setWindowIcon(QIcon(":/images/logo.png"));
	setWindowTitle(tr("auswertung1"));

	tab = new Tabelle1();
	tab->setModel(model);
	appendView(tr("Datentabelle"),tab);

	connect(tab->table()->selectionModel(),SIGNAL(selectionChanged(const QItemSelection&, const QItemSelection&)),this,SLOT(modelSelectionChanged()));

	setCentralWidget(sw);

	undoStack = new QUndoStack(this);

	// Actions
	aImportSM = new QAction(tr("SurveyMonkey"),this);
	aImportCSV = new QAction(tr("CSV"),this);
	aImportViews = new QAction(tr("Views"),this);
	aExport = new QAction(tr("CSV"),this);
	aExportHTML = new QAction(tr("HTML"),this);
	aExportViews = new QAction(tr("Views"),this);
	aNew = new QAction(tr("Neu"),this);
	aOpen = new QAction(QIcon(":images/open.png"),tr("Oeffnen"),this);
	aSave = new QAction(QIcon(":images/save.png"),tr("Speichern"),this);
	aSaveAs = new QAction(QIcon(":images/save.png"),tr("Speichern als..."),this);
	aExit = new QAction(QIcon(":images/quit.png"),tr("Beenden"),this);

	aCopy = new QAction(QIcon(":images/copy.png"),tr("Kopieren"),this);

	aCreateView = new QAction(QIcon(":/images/plus.png"),tr("Ansicht erstellen"),this);
	aRemoveView = new QAction(QIcon(":/images/minus.png"),tr("Ansicht entfernen"),this);
	aHideColumns = new QAction(QIcon(":/images/hidecol.png"),tr("Spalten entfernen"),this);
	aClearViews = new QAction(QIcon(":images/viewremoveall.png"),tr("Alle Ansichten entfernen"),this);

	aRemoveView->setEnabled(false);

	aRenameColumn = new QAction(QIcon(":images/colrename.png"),tr("Spalte umbenennen"),this);
	aReplaceInColumn = new QAction(QIcon(":images/colreplace.png"),tr("Werte ersetzen"),this);
	aCombineColumn = new QAction(QIcon(":images/colcombine.png"),tr("Spalten zusammenfassen"),this);
	aWeightColumn = new QAction(QIcon(":images/colweigth.png"),tr("Spalten gewichten"),this);
	aNormColumn = new QAction(QIcon(":images/colpercent.png"),tr("Spalten normieren"),this);
	aNumColumn = new QAction(QIcon(":images/colclean.png"),tr("Spalten als Zahlen"),this);
	aStatColumn = new QAction(QIcon(":/images/colstat.png"),tr("Spaltenstatistik"),this);
	aCopyColumns = new QAction(QIcon(":/images/colcopy.png"),tr("Spalten kopieren"),this);

	aGotoColumn = new QAction(QIcon(":/images/gotocol.png"),tr("gehe zu Spalte..."),this);

	aLinReg = new QAction(QIcon(":/images/collinreg.png"),tr("Regression"),this);
	
	aHome = new QAction(QIcon(":/images/gohome.png"),tr("Daten"),this);

	QAction *aUndo = undoStack->createUndoAction(this);
	QAction *aRedo = undoStack->createRedoAction(this);

	// Shortcuts

	aCopy->setShortcut(Qt::CTRL + Qt::Key_C);
	aSave->setShortcut(Qt::CTRL + Qt::Key_S);
	aOpen->setShortcut(Qt::CTRL + Qt::Key_O);
	aExit->setShortcut(Qt::CTRL + Qt::Key_Q);

	aStatColumn->setShortcut(Qt::CTRL + Qt::Key_D);
	aGotoColumn->setShortcut(Qt::CTRL + Qt::Key_G);
	aCreateView->setShortcut(Qt::CTRL + Qt::Key_Plus);

	aUndo->setShortcut(Qt::CTRL + Qt::Key_Z);
	aRedo->setShortcut(Qt::CTRL + Qt::SHIFT + Qt::Key_Z);

	// Verbinden
	connect(aHome,SIGNAL(triggered()),this,SLOT(goHome()));
	connect(aNew,SIGNAL(triggered()),this,SLOT(createDemoViews()));
	connect(aOpen,SIGNAL(triggered()),this,SLOT(loadFile()));
	connect(aSave,SIGNAL(triggered()),this,SLOT(saveFile()));
	connect(aSaveAs,SIGNAL(triggered()),this,SLOT(saveFileAs()));
	connect(aImportSM,SIGNAL(triggered()),this,SLOT(importSMFile()));
	connect(aImportCSV,SIGNAL(triggered()),this,SLOT(importFile()));
	connect(aImportViews,SIGNAL(triggered()),this,SLOT(importViewsFile()));
	connect(aExport,SIGNAL(triggered()),this,SLOT(exportFile()));
	connect(aExportHTML,SIGNAL(triggered()),this,SLOT(exportHTMLFile()));
	connect(aExportViews,SIGNAL(triggered()),this,SLOT(exportViewsFile()));
	connect(aExit,SIGNAL(triggered()),qApp,SLOT(quit()));
	connect(aRemoveView,SIGNAL(triggered()),this,SLOT(removeCurrentView()));
	connect(aHideColumns,SIGNAL(triggered()),this,SLOT(hideSelectedColumns()));
	connect(aCreateView,SIGNAL(triggered()),this,SLOT(createSelectedView()));
	connect(aCopy,SIGNAL(triggered()),this,SLOT(clipCopyView()));
	connect(aRenameColumn,SIGNAL(triggered()),this,SLOT(dataRenameColumn()));
	connect(aReplaceInColumn,SIGNAL(triggered()),this,SLOT(dataReplaceColumns()));
	connect(aCombineColumn,SIGNAL(triggered()),this,SLOT(dataCombineColumns()));
	connect(aWeightColumn,SIGNAL(triggered()),this,SLOT(dataWeightColumns()));
	connect(aNormColumn,SIGNAL(triggered()),this,SLOT(dataNormalizeColumn()));
	connect(aNumColumn,SIGNAL(triggered()),this,SLOT(dataNumericColumns()));
	connect(aStatColumn,SIGNAL(triggered()),this,SLOT(dataStatColumns()));
	connect(aClearViews,SIGNAL(triggered()),this,SLOT(clearViews()));
	connect(aGotoColumn,SIGNAL(triggered()),this,SLOT(viewGotoColumn()));
	connect(aLinReg,SIGNAL(triggered()),this,SLOT(dataLinReg()));
	connect(aCopyColumns,SIGNAL(triggered()),this,SLOT(dataCopyColumns()));

	// Dockwidgets
	QDockWidget *dw1 = new QDockWidget(tr("Ansichten"),this);
	vList = new QListView(dw1);
	vList->setModel(vmodel);
	vList->setEditTriggers(QAbstractItemView::EditKeyPressed);
	vList->setContextMenuPolicy(Qt::CustomContextMenu);
	//Internal Movement
	//vList->setMovement(QListView::Snap);
	//vList->setGridSize(QSize(100,15));
	//vList->setViewMode(QListView::IconMode);
	// Drag'n Drop
	//vList->setDragEnabled(true);
	//vList->setAcceptDrops(true);
	//vList->setDropIndicatorShown(true);
	//vList->setDragDropMode(QAbstractItemView::InternalMove);
	// Connect
	connect(vList,SIGNAL(customContextMenuRequested(const QPoint&)),this,SLOT(vListContextMenu(const QPoint&)));

	dw1->setWidget(vList);
	dw1->setObjectName("viewdock");

	QDockWidget *dw2 = new QDockWidget(tr("Text"),this);
	tText = new QTextEdit(dw2);
	dw2->setWidget(tText);
	dw2->setObjectName("textdock");

	addDockWidget(Qt::LeftDockWidgetArea,dw1);
	addDockWidget(Qt::BottomDockWidgetArea,dw2);

	connect(cb,SIGNAL(activated(int)),sw,SLOT(setCurrentIndex(int)));
	connect(sw,SIGNAL(currentChanged(int)),this,SLOT(widgetChanged(int)));
	connect(vList,SIGNAL(activated(const QModelIndex&)),this,SLOT(vListActivated(const QModelIndex&)));

	QToolBar *tb = addToolBar(tr("Ansichten"));
	tb->setObjectName("tbViews");
	tb->addWidget(new QLabel(tr("Ansichten")));
	tb->addWidget(cb);
	tb->addAction(aHome);
	
	QToolBar *tc = addToolBar(tr("Diagramme"));
	tc->setObjectName("tbDiag");
	tc->addAction(aCreateView);
	tc->addAction(aRemoveView);
	
	QToolBar *ta = addToolBar(tr("Spalten"));
	ta->setObjectName("tbColumns");
	ta->addAction(aGotoColumn);
	ta->addAction(aHideColumns);
	ta->addAction(aCopyColumns);
	ta->addSeparator();
	ta->addAction(aStatColumn);
	ta->addAction(aLinReg);
	ta->addSeparator();
	ta->addAction(aRenameColumn);
	ta->addAction(aNormColumn);
	ta->addAction(aNumColumn);
	ta->addAction(aReplaceInColumn);
	ta->addSeparator();
	ta->addAction(aWeightColumn);
	ta->addAction(aCombineColumn);
	
	QMenu *mFile = menuBar()->addMenu(tr("Datei"));
	mFile->addAction(aNew);
	mFile->addAction(aOpen);
	mFile->addAction(aSave);
	mFile->addAction(aSaveAs);
	mFile->addSeparator();
	QMenu *mImport = mFile->addMenu(tr("Import"));
	mImport->addAction(aImportCSV);
	mImport->addAction(aImportSM);
	mImport->addAction(aImportViews);
	QMenu *mExport = mFile->addMenu(tr("Export"));
	mExport->addAction(aExport);
	mExport->addAction(aExportViews);
	mExport->addAction(aExportHTML);
	mFile->addSeparator();
	mFile->addAction(aExit);

	QMenu *mEdit = menuBar()->addMenu(tr("Bearbeiten"));
	mEdit->addAction(aUndo);
	mEdit->addAction(aRedo);
	mEdit->addSeparator();
	mEdit->addAction(aCopy);
	mEdit->addSeparator();
	mEdit->addAction(aCopyColumns);
	mEdit->addAction(aGotoColumn);

	QMenu *mColumn = menuBar()->addMenu(tr("Spalten"));
	mColumn->addAction(aHideColumns);
	mColumn->addSeparator();
	mColumn->addAction(aRenameColumn);
	mColumn->addAction(aReplaceInColumn);
	mColumn->addAction(aNormColumn);
	mColumn->addAction(aNumColumn);
	mColumn->addSeparator();
	mColumn->addAction(aCombineColumn);
	mColumn->addAction(aWeightColumn);
	mColumn->addSeparator();
	mColumn->addAction(aStatColumn);
	mColumn->addAction(aLinReg);

	QMenu *mDiag = menuBar()->addMenu(tr("Diagramme"));
	mDiag->addAction(aHome);
	mDiag->addSeparator();
	mDiag->addAction(aCreateView);
	mDiag->addAction(aRemoveView);
	mDiag->addSeparator();
	mDiag->addAction(aClearViews);

	QMenu *mView = menuBar()->addMenu(tr("Ansicht"));
	mView->addAction(dw1->toggleViewAction());
	mView->addAction(dw2->toggleViewAction());
	mView->addSeparator();
	mView->addAction(ta->toggleViewAction());
	mView->addAction(tb->toggleViewAction());

	QSettings c;
	restoreState(c.value("MainWindow/state").toByteArray());
	resize(c.value("MainWindow/size",QSize(800,550)).toSize());
	
	createDemoViews();
	modelSelectionChanged();

}

View::~View()
{
	QSettings c;
	c.setValue("MainWindow/state",saveState());
	c.setValue("MainWindow/size",size());
}

void View::importFile()
{
	QString fo;
	QString s = QFileDialog::getOpenFileName(this,tr("Choose a file"),QDir::homePath(),tr("Datafiles (*.csv);;All (*.*)"),&fo);
	if (s.isEmpty()) return;
	if (s.endsWith(".csv"))	importCSV(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
	widgetChanged(0);
}

void View::importCSV(const QString &s)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	clearViews();

	// Datei Lesen
	QFile file(s);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return;

	QTextStream in(&file);
	int rcc=0;
	model->clear();
	undoStack->clear();
	while (!in.atEnd())
	{
		QString line = in.readLine();// Zeile Einlesen
		if (line.left(1)=="#") continue; // Komentar

		QStringList li = line.split(';');

		for (int i=0;i<li.count();++i)
		{
			while (li[i].left(1)=="\"" && !li[i].endsWith("\""))
			{ // Zusammengeh�ende zusammenfassen
				li[i]+=li[i+1];
				li.removeAt(i+1);
			}

			if (li[i].left(1)=="\"" && li[i].endsWith("\""))
			{// "" entfernen
				li[i].chop(1);
				li[i].remove(0,1);
			}
		}
		rcc++;
		if (rcc==1)
		{
			model->setColumnCount(li.count());
			model->setHorizontalHeaderLabels(li);
			continue;
		}
		// Eintragen
		
		QList<QStandardItem*> ri;
		for (int i=0;i<li.count();++i)
		{
			ri << new QStandardItem(li[i]);
		}
		model->appendRow(ri);
	}
	file.close();

	createViews();// Neue Ansichten erstellen
	QApplication::restoreOverrideCursor(); // Cursor normal
}

void View::removeCurrentView()
{
	int i = sw->currentIndex();
	QModelIndex idx = vmodel->index(i,0);
	
	QString tt,ad,dg,tx;
	QStringList sp;
	QByteArray param;

	// Ansicht auslesen
	tt = vmodel->data(idx).toString();
	ad = vmodel->data(idx,Qt::UserRole+1).toString();
	dg = vmodel->data(idx,Qt::UserRole+3).toString();
	sp = vmodel->data(idx,Qt::UserRole+2).toStringList();
	tx = vmodel->data(idx,Qt::UserRole+4).toString();
	ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(idx.row()));
	if (mc)
	{
		QDataStream out(&param,QIODevice::WriteOnly);
		mc->saveData(out);
	}
	QVector<int> spl;
	foreach(QString s,sp) spl << s.toInt();
	
	undoStack->push(new cRemoveView(this,mc,tt,ad,dg,tx,spl,param));
}

void View::removeView(int i)
{
	if (i<=0) return;
	QWidget * w = sw->widget(i);
	sw->removeWidget(w);
	vmodel->removeRow(i);
	delete w;
}

void View::removeView(ModelClient *w) 
{
	if (!w) return;
	int i = sw->indexOf(w);
	sw->removeWidget(w);
	vmodel->removeRow(i);
	delete w;
}

QStandardItem * View::appendView(const QString &title,ModelClient *view)
{
	sw->addWidget(view);
	QList<QStandardItem *> l;
	QStandardItem *it = new QStandardItem(title);
	it->setData(view);
	if (view->inherits("ModelDiagramAdapter"))
	{
		it->setData("Single",Qt::UserRole);
	}
	else if (view->inherits("ModelMultiDiagramAdapter"))
	{
		it->setData("Multi",Qt::UserRole);
	}
	else it->setData("Special",Qt::UserRole);
	it->setData("",Qt::UserRole+4);//Text
	l.append(it);
	vmodel->appendRow(l);
	cb->setCurrentIndex(vmodel->rowCount()-1);
	if (vList) vList->setCurrentIndex(vmodel->index(vmodel->rowCount()-1,0));
	return it;
}

void View::createViews()
{
	bool ok;
	QString defDiagram = QInputDialog::getItem(this,tr("Ansichten erzeugen"),tr("Welcher Diagramtyp soll verwendet werden?"),Diagramme,1,false,&ok);
	if (!ok) return;
	QString defAdapter = QInputDialog::getItem(this,tr("Ansichten erzeugen"),tr("Welcher Adapter soll verwendet werden?"),Adapter,1,false,&ok);
	if (!ok) return;
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));

	for (int i=0;i<model->columnCount();++i)	tab->table()->setColumnHidden(i,false);

	// Neue Ansichten erstellen
	for (int i=0;i<model->columnCount();++i)
	{
		QString l = model->headerData(i,Qt::Horizontal).toString();
		if (l.isEmpty()) l = QString::number(i+1);
		createView(defAdapter,defDiagram,QVector<int>()<<i,l);
	}

	cb->setCurrentIndex(0);
	vList->setCurrentIndex(vmodel->index(0,0));
	sw->setCurrentIndex(0);
	QApplication::restoreOverrideCursor();
}

void View::createDemoViews()
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	_filename = QString();
	model->clear();
	undoStack->clear();
	clearViews();

	// Zufallsdaten
	model->setRowCount(100);
	model->setColumnCount(9);

	QStringList demo1;
	demo1 << "Alpha" << "Beta" << "Gamma" << "Delta" << "keine" << "andere";

	QStringList headerLabels;
	headerLabels << "Text" << "0-8" << "0-99" << "0-2" << "0-3" << "0-3" << "0-3" << "0-3" << "0-3";
	model->setHorizontalHeaderLabels(headerLabels);

	for (int i=0;i<100;++i)
	{
		model->setData(model->index(i,0),demo1[rand()%6]);
		model->setData(model->index(i,1),rand()%8);
		model->setData(model->index(i,2),rand()%100);
		model->setData(model->index(i,3),rand()%3);
		model->setData(model->index(i,4),rand()%4);
		model->setData(model->index(i,5),rand()%4);
		model->setData(model->index(i,6),rand()%4);
		model->setData(model->index(i,7),rand()%4);
		model->setData(model->index(i,8),rand()%4);
	}

	// Diagramme

	createView("H\344ufigkeit","TortenDiagram",QVector<int>()<<0,model->headerData(0,Qt::Horizontal).toString());

	createView("H\344ufigkeit","TortenDiagram",QVector<int>()<<1,model->headerData(1,Qt::Horizontal).toString());

	createView("Direkt","TortenDiagram",QVector<int>()<<2,model->headerData(2,Qt::Horizontal).toString());

	createView("H\344ufigkeit %","TortenDiagram",QVector<int>()<<3,model->headerData(3,Qt::Horizontal).toString());
	createView("H\344ufigkeitsVerteilung","BalkenDiagram(H)",QVector<int>()<<4,model->headerData(4,Qt::Horizontal).toString());

	HaeufigkeitsDiagramAdapter *tv1 = new HaeufigkeitsDiagramAdapter();
	tv1->setModelColumn(0);
	tv1->setDiagram(new TortenDiagram());
	tv1->setTitle(model->headerData(0,Qt::Horizontal).toString());

	HaeufigkeitsDiagramAdapter *tv2 = new HaeufigkeitsDiagramAdapter();
	tv2->setModelColumn(1);
	tv2->setDiagram(new TortenDiagram());
	tv2->setTitle(model->headerData(1,Qt::Horizontal).toString());

	HaeufigkeitsDiagramAdapter *tv3 = new HaeufigkeitsProzentDiagramAdapter();
	tv3->setModelColumn(0);
	tv3->setDiagram(new BalkenDiagram());
	tv3->setTitle(model->headerData(0,Qt::Horizontal).toString());

	HaeufigkeitsDiagramAdapter *tv4 = new HaeufigkeitsProzentDiagramAdapter();
	tv4->setModelColumn(1);
	tv4->setDiagram(new BalkenDiagram());
	tv4->setTitle(model->headerData(1,Qt::Horizontal).toString());

	VierDiagramView *t6 = new VierDiagramView();
	t6->setModel(model);
	t6->setClient(tv1,0);
	t6->setClient(tv2,1);
	t6->setClient(tv3,2);
	t6->setClient(tv4,3);


	createView("Spaltenh\344ufigkeit","TortenDiagram",QVector<int>()<<1<<2<<3,"Mehrspalten Test");
	createView("","\304hnlichkeit",QVector<int>()<<0<<1<<2<<3,"\304hnlichkeits Test");
	//createView("","\304hnlichkeit 3D",QVector<int>()<<0<<1<<2<<3,"\304hnlichkeit 3D Test");

	QVector<int> sp3(3);
	sp3[0]=1;
	sp3[1]=3;
	sp3[2]=4;

	HaeufigkeitsMultiDiagramAdapter *t12 = new HaeufigkeitsMultiDiagramAdapter();
	t12->setSpalten(sp3);
	t12->setDiagram(new BalkenDiagram());

	HaeufigkeitsProzentMultiDiagramAdapter *t13 = new HaeufigkeitsProzentMultiDiagramAdapter();
	t13->setSpalten(sp3);
	t13->setDiagram(new BalkenDiagram());

	VierDiagramView *t14 = new VierDiagramView();
	t14->setModel(model);
	t14->setClient(t12,0);
	t14->setClient(t13,1);

	HaeufigkeitsProzentMultiDiagramAdapter *t15 = new HaeufigkeitsProzentMultiDiagramAdapter();
	t15->setModel(model);
	t15->setSpalten(sp3);
	t15->setDiagram(new ExcelBalkenDiagram());

	// In Listen eintragen
	appendView(tr("Vier Ansichten"),t6);
	appendView(tr("H\344ufigkeits Multi Test"),t14);
	appendView(tr("H\344ufigkeits Multi Excel"),t15);

	// Mehr Diagramme
	for (int i=1;i<model->columnCount();++i)
	{
		createView("H\344ufigkeitsVerteilung","BalkenDiagram(H)",QVector<int>()<<i,tr("Balken Direkt Spalte %1").arg(i+1));
	}

	for (int i=0;i<model->columnCount();++i)
	{
		createView("H\344ufigkeit %","BalkenDiagram(V)",QVector<int>()<<i,tr("Balken H\344ufigkeit Spalte %1").arg(i+1));
	}

	cb->setCurrentIndex(0);
	vList->setCurrentIndex(vmodel->index(0,0));
	sw->setCurrentIndex(0);
	QApplication::restoreOverrideCursor();
}

void View::createSelectedView()
{
	bool ok;
	QStringList dlglst;
	dlglst += Diagramme;
	dlglst += DiagramOnly;

	QString diag = QInputDialog::getItem(this, tr("Ansicht erstellen"),tr("Diagram Typ"), dlglst, 0, false, &ok);

	if (!ok || diag.isEmpty()) return; // nichts ausgewaehlt

	// Spalten auslesen
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	if (DiagramOnly.contains(diag))
	{ // Diagrammtyp ohne Adapter
		QString t = QInputDialog::getText(this, tr("Ansicht erstellen"),tr("Titel"));
		if (t.isEmpty()) return;

		createView("",diag,spalten,t);
	}
	else if (spalten.count()==1)
	{
		QString ad = QInputDialog::getItem(this, tr("Ansicht erstellen"),tr("Adapter Typ"), Adapter, 0, false, &ok);
		if (!ok || ad.isEmpty()) return;
		createView(ad,diag,spalten,tr("%2: Spalte %1").arg(spalten[0]+1).arg(diag));
	}
	else if (spalten.count()>1)
	{
		// ModelAdapter abfragen
		QString ad = QInputDialog::getItem(this, tr("Ansicht erstellen"),tr("Adapter Typ"), MultiAdapter, 0, false, &ok);
		if (!ok || ad.isEmpty()) return;

		QString t = QInputDialog::getText(this, tr("Ansicht erstellen"),tr("Titel"));
		if (t.isEmpty()) return;

		createView(ad,diag,spalten,t);
	}
	widgetChanged(vmodel->rowCount()-1);
}

void View::widgetChanged(int idx)
{    // current widget Changed -> Display coresponding Text and save current
	QString t = tText->toHtml();
	vmodel->setData(vmodel->index(curIdx,0),t,Qt::UserRole + 4);
	tText->setHtml(vmodel->data(vmodel->index(idx,0),Qt::UserRole +4).toString());
	curIdx = idx;
	vList->setCurrentIndex(vmodel->index(idx,0));
	cb->setCurrentIndex(idx);
	sw->setCurrentIndex(idx);

	// Actions anpassen
	if (idx==0)
	{
		aCopy->setEnabled(false);
		aRemoveView->setEnabled(false);
		modelSelectionChanged();
		tText->setEnabled(false);
		aGotoColumn->setEnabled(true);
		aCopyColumns->setEnabled(true);
		aHome->setEnabled(false);
	}
	else
	{
		aCopy->setEnabled(true);
		aRemoveView->setEnabled(true);
		tText->setEnabled(true);
		aGotoColumn->setEnabled(false);
		aCopyColumns->setEnabled(false);
		aHome->setEnabled(true);
		// Create Views only from Datatable
		aCombineColumn->setEnabled(false);
		aCreateView->setEnabled(false);
		aHideColumns->setEnabled(false);
		aNormColumn->setEnabled(false);
		aNumColumn->setEnabled(false);
		aReplaceInColumn->setEnabled(false);
		aRenameColumn->setEnabled(false);
		aStatColumn->setEnabled(false);
		aLinReg->setEnabled(false);
		aWeightColumn->setEnabled(false);
	}
}

void View::clipCopyView()
{
	QClipboard *clipboard = QApplication::clipboard();
	QWidget *w = sw->currentWidget();
	TextInhalt *ti = dynamic_cast<TextInhalt*>(w);
	if(ti)
	{
		clipboard->setText(ti->toText());
		return;
	}
	DiagramAdapter *da = dynamic_cast<DiagramAdapter *>(w);
	if(da)
	{
		TextInhalt *ti = dynamic_cast<TextInhalt*>(da->diagram());
		if(ti)
		{
			clipboard->setText(ti->toText());
			return;
		}	
	}
	QPixmap px = QPixmap::grabWidget(w);// Get Image
	clipboard->setImage(px.toImage());
}

void View::importSMFile()
{
	QString fo;
	QString s = QFileDialog::getOpenFileName(this,tr("Choose a file"),QDir::homePath(),tr("Survey Monkey Files (*.csv);;All (*.*)"),&fo);
	if (s.isEmpty()) return;
	if (s.endsWith(".csv"))	importSM(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
	widgetChanged(0);
}

void View::importSM(const QString &filename)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	clearViews();

	// Datei Lesen
	QFile file(filename);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return;

	QTextStream in(&file);
	int rcc=0;
	model->clear();
	undoStack->clear();
	while (!in.atEnd())
	{
		QString line = in.readLine();// Zeile Einlesen
		if (line.left(1)=="#") continue; // Komentar

		QStringList li = line.split(',');

		for (int i=0;i<li.count();++i)
		{
			while (li[i].left(1)=="\"" && !li[i].endsWith("\""))
			{ // Zusammengehoerende zusammenfassen
				li[i]+=li[i+1];
				li.removeAt(i+1);
			}

			if (li[i].left(1)=="\"" && li[i].endsWith("\""))
			{// "" entfernen
				li[i].chop(1);
				li[i].remove(0,1);
			}
		}
		rcc++;
		if (rcc==1)
		{
			model->setColumnCount(li.count());
			model->setHorizontalHeaderLabels(li);
			continue;
		}
		else if (rcc==2)
		{
			ColType = li;
			continue;
		}
		// Eintragen
		QList<QStandardItem*> ri;
		for (int i=0;i<li.count();++i)
		{
			ri << new QStandardItem(li[i]);
		}
		model->appendRow(ri);
	}
	file.close();


	createViewsSM();// Neue Ansichten erstellen

	QApplication::restoreOverrideCursor(); // Cursor normal
}

void View::vListActivated(const QModelIndex & index)
{
	const int r =index.row();
	sw->setCurrentIndex(r);
	widgetChanged(r);
	cb->setCurrentIndex(r);
	widgetChanged(r);
}

void View::createViewsSM()
{
	for (int i=0;i<model->columnCount();++i)
	{
		if (ColType[i].isNull() || ColType[i].isEmpty() || 0==(int)ColType[i].at(0).toAscii())
		{
			tab->table()->setColumnHidden(i,true);
			continue;
		}
		if (ColType[i].left(19)=="Open-Ended Response")
		{

			tab->table()->setColumnHidden(i,false);
			continue;
		}
		tab->table()->setColumnHidden(i,false);
	}

	// Neue Ansichten erstellen
	for (int i=0;i<model->columnCount();++i)
	{
		if (ColType[i].isNull()||ColType[i].isEmpty()) continue;
		if (0==(int)ColType[i].at(0).toAscii()) continue;
		if (ColType[i].left(19)=="Open-Ended Response") continue;

		QString l = model->headerData(i,Qt::Horizontal).toString();
		if (l.isEmpty()) l = QString::number(i+1);
		createView("H\344ufigkeit","BalkenDiagram(H)",QVector<int>()<<i,tr("Balken: %1").arg(l));
	}

	for (int i=0;i<model->columnCount();++i)
	{
		if (ColType[i].isNull()||ColType[i].isEmpty()) continue;
		if (0==(int)ColType[i].at(0).toAscii()) continue;
		if (ColType[i].left(19)=="Open-Ended Response") continue;

		QString l = model->headerData(i,Qt::Horizontal).toString();
		if (l.isEmpty()) l = QString::number(i+1);
		createView("H\344ufigkeit","TortenDiagram",QVector<int>()<<i,QString("Torten:%1").arg(l));
	}
	cb->setCurrentIndex(0);
	vList->setCurrentIndex(vmodel->index(0,0));
	sw->setCurrentIndex(0);
}

void View::clearViews()
{
	// Alte Ansichten loeschen
	for (int i=sw->count()-1;i>=1;i--) // Hinten beginnen und ersten uebrig lassen um die Tabelle zu zeigen!
	{
		QWidget *w=sw->widget(i);
		sw->removeWidget(w);
		vmodel->removeRow(i);
		delete w;
	}
}

void View::dataRenameColumn()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()!=1) return;
	bool ok;
	int r = cols[0].column();
	const QString on = model->headerData(r,Qt::Horizontal).toString();
	const QString nn = QInputDialog::getText(this,tr("Spalte Umbenennen"),tr("Neuer Spaltenname"),QLineEdit::Normal,on,&ok);
	if (!ok) return; // Abgebrochen
	cRenameColumn *c = new cRenameColumn(model,r,on,nn);
	undoStack->push(c);
}

void View::dataReplaceColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()==0) return;
	bool ok;
	const QString ov = QInputDialog::getText(this,tr("Ersetzen"),tr("Alter Wert"),QLineEdit::Normal,QString(),&ok);
	if (!ok) return; // Abgebrochen
	const QString nv = QInputDialog::getText(this,tr("Ersetzen"),tr("Neuer Wert"),QLineEdit::Normal,ov,&ok);
	if (!ok) return; // Abgebrochen

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));

	undoStack->beginMacro(tr("Werte ersetzen"));

	QModelIndexList idx = tab->table()->selectionModel()->selectedIndexes();
	QSortFilterProxyModel *m2 =  qobject_cast<QSortFilterProxyModel *>(tab->table()->model());
	for (int i=0;i<idx.count();++i)
	{
		// Ersetzen
		const QModelIndex id = m2->mapToSource(idx[i]);
		const QVariant v = model->data(id);
		if (v.toString()==ov) undoStack->push(new cInsertData(id,v,nv));
	}

	undoStack->endMacro();

	QApplication::restoreOverrideCursor();
}

void View::dataCombineColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<=1) return;
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	bool ok;
	const QString title = QInputDialog::getText(this,tr("Zusammenfgen"),tr("Titel der neuen Spalte"),QLineEdit::Normal,QString(),&ok);
	if (!ok) return; // Abgebrochen
	int ret = QMessageBox::question(this,tr("Zusammenfgen"),tr("Werte beibehalten?"),QMessageBox::Yes|QMessageBox::No,QMessageBox::Yes);
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	const int col = model->columnCount();

	undoStack->beginMacro(tr("Spalten zusammenfassen"));
	//undoStack->push(new cInsertColumn(model,col,title));

	QList<QStandardItem*> colData;
	
	for (int j=0;j<model->rowCount();++j)
	{
		const QModelIndex target = model->index(j,col);
		QString d;
		int rc=0;
		for (int i=0;i<spalten.count();++i)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			if (rc++>0) d += ",";
			if (ret==QMessageBox::No) d += QString::number(i+1); else d+=v.toString();
		}
		QStandardItem *it = new QStandardItem(d);
		colData << it;	
	}
	undoStack->push(new cAppendColumn(model,colData,title));
	hideSelectedColumns();
	undoStack->endMacro();
	QApplication::restoreOverrideCursor();
}

void View::exportCSV(const QString &filename)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	QFile file(filename);
	if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) return;
	QTextStream out(&file);

	out << "#Erstellt mit auswertung1\n";

	int rc=0;
	for (int i=0;i<model->columnCount();++i)
	{
		if (tab->table()->isColumnHidden(i)) continue;
		if (rc++>0) out << ";";
		out << "\"" << model->headerData(i,Qt::Horizontal).toString()<< "\"";
	}
	out<<"\n";

	for (int j=0;j<model->rowCount();++j)
	{
		int rc=0;
		for (int i=0;i<model->columnCount();++i)
		{
			if (tab->table()->isColumnHidden(i)) continue;
			if (rc++>0) out << ";";
			const QModelIndex idx = model->index(j,i);
			out << "\""<< model->data(idx).toString()<< "\"";
		}
		out<<"\n";
	}
	file.close();
	QApplication::restoreOverrideCursor();
}

void View::exportFile()
{
	QString fo;
	QString s = QFileDialog::getSaveFileName(this,tr("Choose a file"),QDir::homePath(),tr("Datafiles (*.csv)"),&fo);
	if (s.isEmpty()) return;
	if (!s.endsWith(".csv"))	s+=".csv";
	exportCSV(s);
	//setWindowTitle(tr("Auswertung1 - %1").arg(s));
}

void View::exportViewsCSV(const QString&filename)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	QFile file(filename);
	if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) return;
	QTextStream out(&file);

	out << "#Erstellt mit auswertung1\n";
	out << "#Views Version:"<<FILEVERSION<<"\n";

	for (int j=1;j<vmodel->rowCount();++j)
	{
		const QModelIndex idx = vmodel->index(j,0);
		out << "\""<< vmodel->data(idx).toString()<< "\"";
		for (int i=0;i<=4;++i)
		{
			if (i==2)
			{
				QStringList l = vmodel->data(idx,Qt::UserRole+i).toStringList();
				out << ";\"" << l.join(",") << "\"";
			}
			else if (i==4)
			{
				QByteArray ht = vmodel->data(idx,Qt::UserRole+i).toByteArray();
				out << ";\"" << ht.toBase64() << "\"";
			}

			else out << ";\""<< vmodel->data(idx,Qt::UserRole+i).toString()<< "\"";
		}

		// Parameter
		ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(j));
		if (mc)
		{
			QByteArray param;
			QBuffer b(&param);
			b.open(QIODevice::WriteOnly);
			QDataStream out2(&b);
			mc->saveData(out2,FILEVERSION);
			b.close();
			QString o = param.toBase64();
			out << ";\"" << o  << "\"\n";
		}
		else
			out << "ERROR\n";

	}
	file.close();
	QApplication::restoreOverrideCursor();
}

void View::exportViewsFile()
{
	QString fo;
	QString s = QFileDialog::getSaveFileName(this,tr("Choose a file"),QDir::homePath(),tr("Datafiles (*.csv)"),&fo);
	if (s.isEmpty()) return;
	if (!s.endsWith(".csv"))	s+=".csv";
	exportViewsCSV(s);
	//setWindowTitle(tr("Auswertung1 - %1").arg(s));
}

ModelClient * View::createView(const QString& adapter,const QString & diagram,const QVector<int>& spalten,const QString& title,const QString &text)
{
	if (diagram=="\304hnlichkeit")
	{
		if (spalten.count()<=1) return 0;

		ModelAenlichkeitsTabelle *dlg = new ModelAenlichkeitsTabelle();
		dlg->setModel(model);
		dlg->setSpalten(spalten);

		QStandardItem *it = appendView(title,dlg);
		it->setData(diagram,Qt::UserRole+3);
		it->setData(adapter,Qt::UserRole+1);
		it->setData(text,Qt::UserRole+4);
		QStringList l;
		for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
		it->setData(l,Qt::UserRole+2);//spalten
		
		sw->setCurrentWidget(dlg);
		return dlg;
	}

	if (diagram=="\304hnlichkeit 3D")
	{
		if (spalten.count()<=1) return 0;

		ModelAenlichkeits3dView *dlg = new ModelAenlichkeits3dView();
		dlg->setModel(model);
		dlg->setSpalten(spalten);

		QStandardItem *it = appendView(title,dlg);
		it->setData(diagram,Qt::UserRole+3);
		it->setData(adapter,Qt::UserRole+1);
		it->setData(text,Qt::UserRole+4);
		QStringList l;
		for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
		it->setData(l,Qt::UserRole+2);//spalten
		sw->setCurrentWidget(dlg);
		return dlg;
	}

	if (diagram=="Statistik")
	{
		if (spalten.count()<=1) return 0;

		StatistikTabelle *dlg = new StatistikTabelle();
		dlg->setModel(model);
		dlg->setSpalten(spalten);

		QStandardItem *it = appendView(title,dlg);
		it->setData(diagram,Qt::UserRole+3);
		it->setData(adapter,Qt::UserRole+1);
		it->setData(text,Qt::UserRole+4);
		QStringList l;
		for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
		it->setData(l,Qt::UserRole+2);//spalten
		sw->setCurrentWidget(dlg);
		return dlg;
	}

	if (diagram=="XYPlotter")
	{
		if (spalten.count()!=2) return 0;

		XYPlotter *dlg = new XYPlotter();
		dlg->setModel(model);
		dlg->setSpalten(spalten[0],spalten[1]);

		QStandardItem *it = appendView(title,dlg);
		it->setData(diagram,Qt::UserRole+3);
		it->setData(adapter,Qt::UserRole+1);
		it->setData(text,Qt::UserRole+4);
		QStringList l;
		for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
		it->setData(l,Qt::UserRole+2);//spalten
		sw->setCurrentWidget(dlg);
		return dlg;
	}

	if (diagram=="Lineare Regression")
	{
		if (spalten.count()!=2) return 0;

		LineareRegression *dlg = new LineareRegression();
		dlg->setModel(model);
		dlg->setSpalten(spalten[0],spalten[1]);

		QStandardItem *it = appendView(title,dlg);
		it->setData(diagram,Qt::UserRole+3);
		it->setData(adapter,Qt::UserRole+1);
		it->setData(text,Qt::UserRole+4);
		QStringList l;
		for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
		it->setData(l,Qt::UserRole+2);//spalten
		sw->setCurrentWidget(dlg);
		return dlg;
	}
	
	Diagram *dgrm = createDiagram(diagram);

	if (spalten.count()==1)
	{
		ModelDiagramAdapter *mda = 0;
		if (adapter=="Direkt")
		{
			mda = new DirektDiagramAdapter();
		}
		else if (adapter=="H\344ufigkeit")
		{
			mda = new HaeufigkeitsDiagramAdapter();
		}
		else if (adapter=="H\344ufigkeit %")
		{
			mda = new HaeufigkeitsProzentDiagramAdapter();
		}
		else if (adapter=="H\344ufigkeitsVerteilung")
		{
			mda = new HaeufigkeitsVerteilungsAdapter();
		}
		else if (adapter=="Chi Quadrat")
		{
			mda = new ChiQuadrat();
		}

		int col = spalten[0];
		if (mda)
		{
			mda->setModelColumn(col);
			mda->setModel(model);
			mda->setDiagram(dgrm);
			mda->setTitle(title);
			QStandardItem *it = appendView(title,mda);
			it->setData(diagram,Qt::UserRole+3);
			it->setData(adapter,Qt::UserRole+1);
			it->setData(text,Qt::UserRole+4);
			QStringList l;
			for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
			it->setData(l,Qt::UserRole+2);//spalten
			sw->setCurrentWidget(mda);
			connect(mda,SIGNAL(changeDiagram(DiagramAdapter*)),this,SLOT(changeDiagram(DiagramAdapter*)));
		}
		return mda;
	}
	else if (spalten.count()>1)
	{
		ModelMultiDiagramAdapter *mda = 0;
		if (adapter=="Direkt")
		{
			mda = new DirektMultiDiagramAdapter();
		}
		else if (adapter=="Spaltenh\344ufigkeit")
		{
			mda = new SpaltenHaeufigkeitsDiagramAdapter();
		}
		else if (adapter=="H\344ufigkeit")
		{
			mda = new HaeufigkeitsMultiDiagramAdapter();
		}
		else if (adapter=="H\344ufigkeit %")
		{
			mda = new HaeufigkeitsProzentMultiDiagramAdapter();
		}

		if (mda)
		{
			mda->setModel(model);
			mda->setDiagram(dgrm);
			mda->setSpalten(spalten);
			mda->setTitle(title);
			QStandardItem *it = appendView(title,mda);
			it->setData(diagram,Qt::UserRole+3);
			it->setData(adapter,Qt::UserRole+1);
			it->setData(text,Qt::UserRole+4);
			QStringList l;
			for (int i=0;i<spalten.count();++i) l << QString::number(spalten[i]);
			it->setData(l,Qt::UserRole+2);//spalten
			sw->setCurrentWidget(mda);
			connect(mda,SIGNAL(changeDiagram(DiagramAdapter*)),this,SLOT(changeDiagram(DiagramAdapter*)));
		}
		return mda;
	}
	return 0;
}


/*!
    \fn View::importViewsFile()
 */
void View::importViewsFile()
{
	QString fo;
	QString s = QFileDialog::getOpenFileName(this,tr("Choose a file"),QDir::homePath(),tr("Datafiles (*.csv);;All (*.*)"),&fo);
	if (s.isEmpty()) return;
	if (s.endsWith(".csv"))	importViewsCSV(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
	widgetChanged(0);
}


/*!
    \fn View::importViews(const QString &filename)
 */
void View::importViewsCSV(const QString &filename)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	clearViews();

	// Datei Lesen
	QFile file(filename);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return;

	QTextStream in(&file);
	int rcc=0;

	while (!in.atEnd())
	{
		QString line = in.readLine();// Zeile Einlesen
		if (line.left(1)=="#") continue; // Komentar

		QStringList li = line.split(';');

		for (int i=0;i<li.count();++i)
		{
			while (li[i].left(1)=="\"" && !li[i].endsWith("\""))
			{ // Zusammengeh�ende zusammenfassen
				li[i]+=li[i+1];
				li.removeAt(i+1);
			}

			if (li[i].left(1)=="\"" && li[i].endsWith("\""))
			{// "" entfernen
				li[i].chop(1);
				li[i].remove(0,1);
			}
		}
		rcc++;
		QString title,adapter,diagram,sp;
		QByteArray ht;
		title=li[0];
		adapter=li[2];
		sp=li[3];
		diagram=li[4];
		ht = li[5].toUtf8();


		QStringList l = sp.split(",");
		QVector<int> spalten;
		for (int i=0;i<l.count();++i) spalten << l[i].toInt();

		createView(adapter,diagram,spalten,title); // ModelClient erzeugen

		QByteArray htt = QByteArray::fromBase64(ht);// HTML Komentar einlesen
		vmodel->setData(vmodel->index(rcc,0),htt,Qt::UserRole+4);

		if (li.count()>6 && !li[6].isEmpty())
		{
			QByteArray param = QByteArray::fromBase64(li[6].toUtf8()); // Parameter einlesen
			ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(rcc));
			QDataStream in2(param);
			if (mc) mc->loadData(in2,FILEVERSION);
		}

		if (rcc%100==0) QApplication::processEvents();
	}
	file.close();

	QApplication::restoreOverrideCursor(); // Cursor normal
}


/*!
    \fn View::dataWeightColumns()
 */
void View::dataWeightColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<=1) return;
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	bool ok;
	const QString title = QInputDialog::getText(this,tr("Gewichten"),tr("Titel der neuen Spalte"),QLineEdit::Normal,QString(),&ok);
	if (!ok) return; // Abgebrochen
	const QString weights = QInputDialog::getText(this,tr("Gewichten"),tr("Geben sie Gewichtungsfaktoren durch Komma getrennt ein."),QLineEdit::Normal,QString(),&ok);
	if (!ok) return; // Abgebrochen

	QStringList wls = weights.split(",");
	QVector<double> wl;
	foreach(QString i,wls) wl << i.toDouble();

	if (spalten.count()!=wl.count())
	{
		QMessageBox::warning(this,tr("Gewichten"),tr("Die Zahl der Faktoren stimmt nicht\nmit der Zahl der markierten Spalten\nueberein!"),QMessageBox::Ok);
		return;
	}

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	
	QList<QStandardItem*> colData;
	
	undoStack->beginMacro(tr("Spalten gewichten"));
	
	for (int j=0;j<model->rowCount();++j)
	{
		double d=0.0;
		for (int i=0;i<spalten.count();++i)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			d += v.toDouble()*wl[i];
		}
		QStandardItem *it = new QStandardItem();
		it->setData(d,Qt::DisplayRole);
		colData << it;
	}
	undoStack->push(new cAppendColumn(model,colData,title));
	undoStack->endMacro();
	QApplication::restoreOverrideCursor();
}


/*!
    \fn View::dataNormalizeColumn()
 */
void View::dataNormalizeColumn()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<1) return;
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	undoStack->beginMacro(tr("Spalte in Prozent"));

	for (int i=0;i<spalten.count();++i)
	{
		double d=0.0;
		for (int j=0;j<model->rowCount();++j)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			d += v.toDouble();
		}
		for (int j=0;j<model->rowCount();++j)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			undoStack->push(new cInsertData(idx,v,v.toDouble()/d*100.0));
		}
	}
	undoStack->endMacro();
	QApplication::restoreOverrideCursor();
}


/*!
    \fn View::dataNumericColumns()
 */
void View::dataNumericColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<1) return;
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	undoStack->beginMacro(tr("Spalte als Zahlen"));
	for (int i=0;i<spalten.count();++i)
	{
		for (int j=0;j<model->rowCount();++j)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			undoStack->push(new cInsertData(idx,v,""));
			undoStack->push(new cInsertData(idx,"",v.toDouble()));
		}
	}
	undoStack->endMacro();
	QApplication::restoreOverrideCursor();
}


/*!
    \fn View::dataStatColumns()
 */
void View::dataStatColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<1) return;
	QVector<int> spalten;
	for (int i=0;i<cols.count();++i) spalten<<cols[i].column();

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	QVector<double> sp;
	for (int i=0;i<spalten.count();++i)
	{
		for (int j=0;j<model->rowCount();++j)
		{
			const QModelIndex idx = model->index(j,spalten[i]);
			const QVariant v = model->data(idx);
			if (v.isNull() || !v.isValid() || v.toString()=="" || v.toString()=="0") continue;
			sp << v.toDouble();
		}
	}
	std::sort(sp.begin(),sp.end());
	const double min = *std::min_element(sp.begin(),sp.end());
	const double max = *std::max_element(sp.begin(),sp.end());
	const double median = *(sp.begin()+sp.size()/2);
	const double sum = std::accumulate(sp.begin(),sp.end(),0.0);
	const double avg = sum/sp.size();
	const double em = spalten.count()*model->rowCount()-sp.size();
	const double emp = em/(spalten.count()*model->rowCount())*100.0;
	const double vp = sp.count()*100.0/(spalten.count()*model->rowCount());

	QApplication::restoreOverrideCursor();

	QString spt;
	foreach(int s,spalten) spt += QString::number(s+1)+" ";

	const QString msg=tr(
	                      "Statistik fr Spalte: %1\n\n"
	                      "Minimum: %2\n"
	                      "Maximum: %3\n"
	                      "Durchschnitt: %4\n"
	                      "Median: %5\n"
	                      "Summe: %6\n"
	                      "Leer: %7 (%8%)\n"
	                      "Werte: %9 (%10%)\n"
	                  ).arg(spt).arg(min).arg(max).arg(avg).arg(median).arg(sum).arg(em).arg(emp).arg(sp.count()).arg(vp);

	QMessageBox::information(this,tr("Statistik"),msg);
}

/*!
    \fn View::modelSelectionChanged()
 */
void View::modelSelectionChanged()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()==0)
	{
		aCombineColumn->setEnabled(false);
		aCreateView->setEnabled(false);
		aHideColumns->setEnabled(false);
		aNormColumn->setEnabled(false);
		aNumColumn->setEnabled(false);
		aReplaceInColumn->setEnabled(false);
		aRenameColumn->setEnabled(false);
		aStatColumn->setEnabled(false);
		aWeightColumn->setEnabled(false);
	}
	else if (cols.count()==1)
	{
		aCombineColumn->setEnabled(false);
		aCreateView->setEnabled(true);
		aHideColumns->setEnabled(true);
		aNormColumn->setEnabled(true);
		aNumColumn->setEnabled(true);
		aReplaceInColumn->setEnabled(true);
		aRenameColumn->setEnabled(true);
		aStatColumn->setEnabled(true);
		aWeightColumn->setEnabled(false);
	}
	else if (cols.count()>1)
	{
		aCombineColumn->setEnabled(true);
		aCreateView->setEnabled(true);
		aHideColumns->setEnabled(true);
		aNormColumn->setEnabled(true);
		aNumColumn->setEnabled(true);
		aReplaceInColumn->setEnabled(true);
		aRenameColumn->setEnabled(false);
		aStatColumn->setEnabled(true);
		aWeightColumn->setEnabled(true);
	}
	if (cols.count()==2)	aLinReg->setEnabled(true);else aLinReg->setEnabled(false);
}


/*!
    \fn View::hideSelectedColumns()
 */
void View::hideSelectedColumns()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	QVector<int> s;
	foreach(QModelIndex idx,cols) s<<idx.column();
	undoStack->push(new cHideColumns(s,tab->table()));
	//tab->hideSelectedColumns();
}


/*!
    \fn View::loadFile()
 */
void View::loadFile()
{
	QString fo;
	QString s = QFileDialog::getOpenFileName(this,tr("Choose a file"),QDir::homePath(),tr("Statistic (*.stat);;All (*.*)"),&fo);
	if (s.isEmpty()) return;
	load(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
	_filename=s;
	widgetChanged(0);
}


/*!
    \fn View::saveFile()
 */
void View::saveFile()
{
	QString s=_filename;
	if (_filename.isEmpty())
	{
		QString fo;
		s = QFileDialog::getSaveFileName(this,tr("Choose a file"),QDir::homePath(),tr("Statistic (*.stat);;All (*.*)"),&fo);
		if (s.isEmpty()) return;
		_filename=s;
	}
	if (! s.endsWith(".stat")) s+= ".stat";
	save(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
}

/*!
    \fn View::saveFileAs()
 */
void View::saveFileAs()
{
	QString fo;
	QString s  = QFileDialog::getSaveFileName(this,tr("Choose a file"),QDir::homePath(),tr("Statistic (*.stat)"),&fo);
	if (s.isEmpty()) return;
	_filename=s;

	if (! s.endsWith(".stat")) s+= ".stat";
	save(s);
	setWindowTitle(tr("Auswertung1 - %1").arg(s));
}

/*!
    \fn View::load(const QString& filename)
 */
void View::load(const QString& filename)
{
	
	// Datei Lesen
	QFile file(filename);
	if (!file.open(QIODevice::ReadOnly | QIODevice::Text)) return;

	QDataStream in(&file);

	quint32 magic;
	quint16 ver;
	in >> magic;
	if (magic != 0xffaa01bb) return; // Falsches Dateiformat
	in >> ver;
	if (ver>FILEVERSION) return; // Falsche version
	
	in.setVersion(QDataStream::Qt_4_2);

	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	clearViews();
	model->clear();
	undoStack->clear();

	// Datentabelle
	qint32 cols,rows;
	in >> rows >> cols; // Spalten und Zeilenzahl
	//model->setRowCount(rows);
	model->setColumnCount(cols);

	for (int i=0;i<cols;++i)
	{
		bool v;
		QVariant l;
		in >> v >> l;
		tab->table()->setColumnHidden(i,v);
		model->setHeaderData(i,Qt::Horizontal,l);
	}

	for (int j=0;j<rows;++j)
	{
		QList<QStandardItem*> r;
		for (int i=0;i<cols;++i)
		{
			QVariant v;
			in >> v;
			QStandardItem *it = new QStandardItem(v.toString());
			it->setData(v);
			r << it;
		}
		model->appendRow(r);
		//qDebug()<<"row"<<j;
	}

	// Ansichten
	qint32 vrows;
	in >> vrows;

	for (int i=1;i<=vrows;++i)
	{
		QVariant tt,ad,sp,dg,tx;
		in >> tt >> ad >> sp >> dg >> tx;

		QStringList l = sp.toStringList(); // Spalten umwandeln
		QVector<int> spalten;
		for (int j=0;j<l.count();++j) spalten << l[j].toInt();
		
		//qDebug() << "view" << i << tt << ad << sp << dg;

		createView(ad.toString(),dg.toString(),spalten,tt.toString()); // View erzeugen
		const QModelIndex idx = vmodel->index(i,0);

		vmodel->setData(idx,tx,Qt::UserRole+4); // Text

		ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(i));
		if (mc) mc->loadData(in,ver);
	}

	file.close();
	QApplication::restoreOverrideCursor();
	_filename=filename;
	setWindowTitle(tr("auswertung1 - %1").arg(_filename));
}


/*!
    \fn View::save(const QString& filename)
 */
void View::save(const QString& filename)
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	
	if(QFile::exists(filename))
	{
		QFile::remove(filename+"~");
		QFile::rename(filename,filename+"~");
	}
	
	QFile file(filename);
	
	if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) return;
	QDataStream out(&file);

	out << (qint32) 0xffaa01bb; // Magic
	out << (qint16) FILEVERSION;	// Version
	
	out.setVersion(QDataStream::Qt_4_2);
	// Datentabelle
	out << (qint32) model->rowCount() << (qint32) model->columnCount(); // Zeilen- und Spaltenanzahl;

	for (int i=0;i<model->columnCount();++i)
	{
		out << tab->table()->isColumnHidden(i); // Sichtbar
		out << model->headerData(i,Qt::Horizontal); // Ueberschrift
	}

	for (int j=0;j<model->rowCount();++j)
	{
		for (int i=0;i<model->columnCount();++i)
		{
			const QModelIndex idx = model->index(j,i);
			out << static_cast<QVariant>(model->data(idx).toString()); // Daten
		}
	}

	// Ansichten
	out << (qint32) vmodel->rowCount(); // Anzahl der Ansichten

	for (int j=1;j<vmodel->rowCount();++j)
	{
		const QModelIndex idx = vmodel->index(j,0);
		out << vmodel->data(idx);		 // Titel
		out << vmodel->data(idx,Qt::UserRole+1); // Adapter
		out << vmodel->data(idx,Qt::UserRole+2); // Spalten
		out << vmodel->data(idx,Qt::UserRole+3); // Diagram
		out << vmodel->data(idx,Qt::UserRole+4); // Text
		ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(j));
		if (mc) mc->saveData(out,FILEVERSION);
	}

	file.close();
	QApplication::restoreOverrideCursor();
}


/*!
    \fn View::viewGotoColumn()
 */
void View::viewGotoColumn()
{
	bool ok;
	int s = QInputDialog::getInteger(this,tr("Gehe zu Spalte"),tr("Geben sie die Nummer der\ngewuenschten Spalte ein."),1,1,model->columnCount(),1,&ok);
	if (!ok) return;
	// Gehe zu angegebenen Spalte und Markiere sie
	QModelIndex idx = model->index(0,s-1);
	tab->table()->scrollTo(idx,QAbstractItemView::EnsureVisible);
	tab->table()->selectColumn(s-1);
}


/*!
    \fn View::dataLinReg()
 */
void View::dataLinReg()
{
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()!=2) return;
	QVector<int> s;
	foreach(QModelIndex idx,cols) s<<idx.column();
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));

	QVector<double> dx,dy;
	for (int i=0;i<model->rowCount();++i)
	{
		dx << model->data(model->index(i,s[0])).toDouble();
		dy << model->data(model->index(i,s[1])).toDouble();
	}

	const double mx = std::accumulate(dx.begin(),dx.end(),0.0)/dx.size();
	const double my = std::accumulate(dy.begin(),dy.end(),0.0)/dy.size();

	double s1 = 0.0,s2 = 0.0;
	for (int i=0;i<dx.count();++i)
	{
		s1 += (dx[i]-mx) * (dy[i]*my);
		s2 += (dx[i]-mx) * (dx[i]-mx);
	}

	const double m = s1/s2;
	const double a = my - m*mx;

	QApplication::restoreOverrideCursor();

	QString msg;
	if (a>=0.0) msg = tr("Die Gleichung der Regressionsgeraden lautet:\n\ty=%1*x+%2");
	else msg = tr("Die Gleichung der Regressionsgeraden lautet:\n\ty=%1*x-%2");

	QMessageBox::information(this,tr("Lineare Regession"),msg.arg(m).arg(abs(a)));
}


/*!
    \fn View::vListContextMenu(const QPoint& pos)
 */
void View::vListContextMenu(const QPoint& pos)
{
	QModelIndex idx = vList->indexAt(pos);
	QAction aEdit(tr("Umbenennen"),this);
	QAction aDel(tr("Entfernen"),this);
	QAction aDouble(tr("Duplizieren"),this);

	if (idx.row()==0)
	{ // Datentabelle
		aDel.setEnabled(false);
		aDouble.setEnabled(false);
	}

	QMenu mc;
	mc.addAction(&aEdit);
	mc.addAction(&aDouble);
	mc.addSeparator();
	mc.addAction(&aDel);
	QAction *ret = mc.exec(vList->mapToGlobal(pos));
	if (ret == &aEdit) vList->edit(idx);
	else if (ret == &aDouble)
	{
		QString tt,ad,dg,tx;
		QStringList sp;
		QByteArray param;

		// Ansicht auslesen
		tt = vmodel->data(idx).toString();
		ad = vmodel->data(idx,Qt::UserRole+1).toString();
		dg = vmodel->data(idx,Qt::UserRole+3).toString();
		sp = vmodel->data(idx,Qt::UserRole+2).toStringList();
		tx = vmodel->data(idx,Qt::UserRole+4).toString();
		ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(idx.row()));
		if (mc)
		{
			QDataStream out(&param,QIODevice::WriteOnly);
			mc->saveData(out,FILEVERSION);
		}
		
		QVector<int> spl;
		foreach(QString s,sp) spl << s.toInt();
		
		// Ansicht erzeugen
		mc = createView(ad,dg,spl,tt+"(neu)",tx);
		if (mc)
		{
			QDataStream in(param);
			mc->loadData(in,FILEVERSION);
		}
	}
	else if (ret == &aDel)
	{
		int i = idx.row();
		if (i==0) return;
		QModelIndex idx = vmodel->index(i,0);
		
		QString tt,ad,dg,tx;
		QStringList sp;
		QByteArray param;
		
		// Ansicht auslesen
		tt = vmodel->data(idx).toString();
		ad = vmodel->data(idx,Qt::UserRole+1).toString();
		dg = vmodel->data(idx,Qt::UserRole+3).toString();
		sp = vmodel->data(idx,Qt::UserRole+2).toStringList();
		tx = vmodel->data(idx,Qt::UserRole+4).toString();
		ModelClient *mc = qobject_cast<ModelClient *>(sw->widget(idx.row()));
		if (mc)
		{
			QDataStream out(&param,QIODevice::WriteOnly);
			mc->saveData(out,FILEVERSION);
		}
		QVector<int> spl;
		foreach(QString s,sp) spl << s.toInt();
		
		undoStack->push(new cRemoveView(this,mc,tt,ad,dg,tx,spl,param));
	}
}


/*!
    \fn View::moveView(int i,int j)
 */
void View::moveView(int i,int j)
{
	if (i<=0 || i==j) return;
	QWidget * w = sw->widget(i);
	QStandardItem * it = vmodel->takeItem(i);

	vmodel->removeRow(i);
	sw->removeWidget(w);
	
	sw->insertWidget(j,w);
	
	vmodel->insertRow(j,it);
}


/*!
    \fn View::viewIndex(ModelClient*m)
 */
int View::viewIndex(ModelClient*m)
{
	return sw->indexOf(m);
}


/*!
    \fn View::dataCopyColumns()
 */
void View::dataCopyColumns()
{
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	
	QModelIndexList cols = tab->table()->selectionModel()->selectedColumns();
	if (cols.count()<1) return;
	
	QVector<int> spalten;
	foreach(QModelIndex i,cols) spalten<<i.column();

	const int co = spalten.count();
	int col = model->columnCount();
	
	undoStack->beginMacro("Spalten kopieren");
	
	for (int i=0;i<co;++i,++col)
	{
		QList<QStandardItem*> colData;
		for (int j=0;j<model->rowCount();++j)
		{
			QStandardItem * it = model->item(j,spalten[i]);
			colData << it->clone();
		}
		undoStack->push(new cAppendColumn(model,colData,model->headerData(spalten[i],Qt::Horizontal).toString()));
	}
	
	undoStack->endMacro();
	
	QApplication::restoreOverrideCursor();
}


/*!
    \fn View::goHome()
 */
void View::goHome()
{
	sw->setCurrentIndex(0);
}


/*!
    \fn View::askDiagram()
 */
QString View::askDiagram()
{
	bool ok;
	QStringList dlglst;
	dlglst += Diagramme;
	
	QString diag = QInputDialog::getItem(this, tr("Ansicht erstellen"),tr("Diagram Typ"), dlglst, 0, false, &ok);

	if (!ok || diag.isEmpty()) return ""; // nichts ausgewaehlt
	
	return diag;
}


/*!
    \fn View::createDiagram(const QString& dt)
 */
Diagram * View::createDiagram(const QString& diagram)
{
	Diagram *dgrm = 0;
	if (diagram=="TortenDiagram")
	{
		dgrm = new TortenDiagram();
	}
	else if (diagram=="BalkenDiagram(V)")
	{
		dgrm = new BalkenDiagram();
	}
	else if (diagram=="BalkenDiagram(H)")
	{
		dgrm = new BalkenDiagram_h();
	}
	else if (diagram=="XmasDiagram")
	{
		dgrm = new XmasDiagram();
	}
	else if (diagram=="ExcelBalkenDiagram")
	{
		dgrm = new ExcelBalkenDiagram();
	}
	else if (diagram=="Tabelle")
	{
		dgrm = new TabellenDiagramm();
	}

	return dgrm;
}


/*!
    \fn View::changeDiagramm(ModelDiagramAdapter *)
 */
void View::changeDiagram(DiagramAdapter *mda)
{
	if(mda==0) return;
	QString d = askDiagram();
	if(d.isEmpty()) return;
	Diagram *dg = createDiagram(d);
	if(dg) mda->setDiagram(dg);
	QWidget *w = dynamic_cast<QWidget *>(mda);
	int idx = sw->indexOf(w);
	QStandardItem * it = vmodel->item(idx);
	it->setData(d,Qt::UserRole+3);
}


/*!
    \fn View::exportHTMLFile()
 */
void View::exportHTMLFile()
{
	QString s = QFileDialog::getSaveFileName(this,tr("Exportieren als HTML"),QDir::homePath(),tr("HTML (*.html)"));
	if (s.isEmpty()) return;
	if (!s.endsWith(".html")) s+=".html";
	widgetChanged(0);
	exportHTML(s);
}


/*!
    \fn View::exportHTML(const QString &fdirname)
 */
void View::exportHTML(const QString &fdirname)
{
	QString dirname = fdirname;
	if(fdirname.endsWith(".html")) dirname = fdirname.left(fdirname.length()-5)+"_files";
	
	QDir di(fdirname);
	di.mkdir(dirname);
	
	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
	QFile file(fdirname);
	if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) return;
	QTextStream out(&file);

	out << "<HTML><HEAD><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><TITLE></TITLE></HEAD><BODY>";
	out << "<H1>" << _filename << "</H1>";

	for (int j=1;j<vmodel->rowCount();++j)
	{
		const QModelIndex idx = vmodel->index(j,0);
		out << "<H2>"<< vmodel->data(idx).toString()<< "</H2>";
		QString ht = vmodel->data(idx,Qt::UserRole+4).toString();
		QTextDocument htd;
		htd.setHtml(ht);
		ht = htd.toPlainText();
		out << "<PRE>" << ht << "</PRE>";
		QWidget *w = sw->widget(j);
		if (w)
		{
			TextInhalt *ti = dynamic_cast<TextInhalt*>(w);
			if(ti)
			{ // Text Auslesen
				out << ti->toHTML();
				continue;
			}
			DiagramAdapter *da = dynamic_cast<DiagramAdapter *>(w);
			if(da)
			{
				TextInhalt *ti = dynamic_cast<TextInhalt*>(da->diagram());
				if(ti)
				{
					out << ti->toHTML();
					continue;
				}	
			}
			QString imgpath = dirname+QDir::separator()+"diagram"+QString::number(j)+".png";
			out << "<IMG src=\""+imgpath+"\" >";
			QPixmap px = QPixmap::grabWidget(w);// Get Image
			px.save(imgpath,"png");
		}
	}
	out << "</BODY></HTML>";
	file.close();
	QApplication::restoreOverrideCursor();
}
