//
// C++ Interface: xyplotter
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef XYPLOTTER_H
#define XYPLOTTER_H

#include <modelclient.h>
#include <QMouseEvent>

class QPaintEvent;

/**
	@author Arne Schmitt <arne@as4m.de>
*/
class XYPlotter : public ModelClient
{
Q_OBJECT
public:
    XYPlotter(QWidget* parent=0);

    ~XYPlotter();
    
    void setSpalten(int x,int y);
    void setModel(QStandardItemModel *m);
    
protected:
	void paintEvent( QPaintEvent *ev);
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	virtual void paint( QPainter &p);
	
protected slots:
	void updateData();
	
protected:
	int SpalteX,SpalteY;
	double minX,minY,maxX,maxY;
	QVector<double> sx,sy;
	double scX,scY;
	QPoint dragStartPosition;
	
};

#endif
